#ifndef _SYSCTL_H
#define _SYSCTL_H

/*==========================================================================  		
Description: 
            
            System controls of hand-held terminal   
              
Histroy:       
        
        1.Version:1.0.0  Date: 2008/05/13 
            
             Frist Release 
           
        2.Version:1.0.1  Date: 2008/09/24  
                      
             Add below functions
           
             a. SysSetFunctionKeySettingState
             b. SysSetFunctionKeySettingState
             c. SysGetLibraryVersion
             
        3.Version:1.0.2  Date: 2008/09/30  
        
             Add functions      
             
             a.SysGetKeyInputMode
             b.SysSetKeyInputMode
            
                                   	            
=============================================================================*/

#ifdef LIB_INTERNAL

#define SYSLIB
#else
      #ifdef __cplusplus
          #define SYSLIB extern "C"	
      #else
          #define SYSLIB extern
      #endif 

#endif


//=====================================
//=         Device Information        =
//=====================================

typedef BOOL (*PFN_GetModelName)   (LPCTSTR lpszModelName);

typedef BOOL (*PFN_GetConfigNumber) (LPCTSTR lpszConfigNumber);

typedef BOOL (*PFN_GetSerialNumber) (LPCTSTR lpszSerialNumber);

SYSLIB  BOOL SysGetModelName(LPCTSTR lpszModelName);

SYSLIB  BOOL SysGetConfigNumber(LPCTSTR lpszConfigNumber);

SYSLIB  BOOL SysGetSerialNumber(LPCTSTR lpszSerialNumber);

//=====================================
//=       Function key controls       =
//=====================================

typedef BOOL (*PFN_GetFunctionKeyPrograms)(DWORD dwFuncKey,LPCTSTR  lpszAppName);

typedef BOOL (*PFN_SetFunctionKeyPrograms)(DWORD dwFuncKey,LPCTSTR  lpszAppName);

typedef BOOL (*PFN_GetFunctionKeySettingState)(PBOOL pEnable);

typedef BOOL (*PFN_SetFunctionKeySettingState)(BOOL bEnable);

typedef BOOL (*PFN_SysGetKeyInputMode)(LPDWORD lpdwInputMode);

typedef BOOL (*PFN_SysSetKeyInputMode)(DWORD dwInputMode);

SYSLIB BOOL SysGetFunctionKeyPrograms(DWORD dwFuncKey,LPCTSTR  lpszAppName);

SYSLIB BOOL SysSetFunctionKeyPrograms(DWORD dwFuncKey,LPCTSTR  lpszAppName);

SYSLIB BOOL SysGetFunctionKeySettingState(PBOOL pEnable);

SYSLIB BOOL SysSetFunctionKeySettingState(BOOL bEnable);

SYSLIB BOOL SysGetKeyInputMode(LPDWORD lpdwInputMode);

SYSLIB BOOL SysSetKeyInputMode(DWORD dwInputMode);

//=====================================
//=       System Power Controls       =
//=====================================

typedef BOOL (*PFN_GetSuspendTime)(DWORD dwPowerMode,LPDWORD lpdwSuspendTime);

typedef BOOL (*PFN_SetSuspendTime)(DWORD dwPowerMode,DWORD dwSuspendTime);
 
typedef BOOL (*PFN_GetBacklightTimeout)(DWORD dwPowerMode,LPDWORD lpdwBacklightTimeout);

typedef BOOL (*PFN_SetBacklightTimeout)(DWORD dwPowerMode,DWORD dwBacklightTimeout); 

typedef BOOL (*PFN_GetPowerDownDisableMode)(PBOOL pbDisableMode);

typedef BOOL (*PFN_SetPowerDownDisableMode)(BOOL bDisableMode);

SYSLIB BOOL SysGetSuspendTime(DWORD dwPowerMode,LPDWORD lpdwSuspendTime);

SYSLIB BOOL SysSetSuspendTime(DWORD dwPowerMode,DWORD dwSuspendTime);

SYSLIB BOOL SysGetBacklightTimeout(DWORD dwPowerMode,LPDWORD lpdwBacklightTimeout);

SYSLIB BOOL SysSetBacklightTimeout(DWORD dwPowerMode,DWORD dwBacklightTimeout);

SYSLIB BOOL SysGetPowerDownDisableMode(PBOOL pbDisableMode);

SYSLIB BOOL SysSetPowerDownDisableMode(BOOL bDisableMode);

//=====================================
//=       WLAN Controls               =
//=====================================

typedef BOOL (*PFN_GetWLANPower)(LPDWORD lpdwPowerStatus);	

typedef BOOL (*PFN_SetWLANPower)(DWORD dwPowerStatus);	

SYSLIB  BOOL SysGetWLANPower(LPDWORD lpdwPowerStatus);

SYSLIB  BOOL SysSetWLANPower(DWORD dwPowerStatus);

//=====================================
//=       Bluetooth Controls          =
//=====================================

typedef BOOL (*PFN_GetBluetoothPower) (LPDWORD lpdwPowerStatus);
  
typedef BOOL (*PFN_SetBluetoothPower) (DWORD dwPowerStatus); 

SYSLIB  BOOL SysGetBluetoothPower(LPDWORD lpdwPowerStatus);

SYSLIB  BOOL SysSetBluetoothPower(DWORD dwPowerStatus);

//=====================================
//=          Backlight Controls       =
//=====================================

typedef BOOL (*PFN_GetBacklightLevel) (PBYTE lpdwLevel);

typedef BOOL (*PFN_SetBacklightLevel) (BYTE dwLevel); 

SYSLIB BOOL SysGetBacklightLevel(PBYTE lpdwLevel);

SYSLIB BOOL SysSetBacklightLevel(BYTE dwLevel);

//=====================================
//=          Other                    =
//=====================================

typedef BOOL (*PFN_GetLibraryVersion) (LPCTSTR lpVersionString);

SYSLIB BOOL SysGetLibraryVersion(LPTSTR lpVersionString);




#define  SYS_MAX_PATH    260 

#define SYS_KEY_F1 1
#define SYS_KEY_F2 2
#define SYS_KEY_F3 3
#define SYS_KEY_F4 4
#define SYS_KEY_F5 5
#define SYS_KEY_F6 6
#define SYS_KEY_F7 7
#define SYS_KEY_F8 8
#define SYS_KEY_Q1 9
#define SYS_KEY_Q2 10


#define SYS_POWER_BATTERY_MODE   0x01

#define SYS_POWER_EXTERNAL_MODE  (0x01<<1)

//Settings for suspend timer

#define SUSPEND_TIME_ONE_MIN       1

#define SUSPEND_TIME_TWO_MIN       2 

#define SUSPEND_TIME_THREE_MIN     3 // battery power mode only

#define SUSPEND_TIME_FOUR_MIN      4 // battery power mode only

#define SUSPEND_TIME_FIVE_MIN      5

#define SUSPEND_TIME_TEN_MIN      10

#define SUSPEND_TIME_FIFTEEN_MIN  15 // external power mode only

#define SUSPEND_TIME_THIRTY_MIN   30 

#define SUSPEND_TIME_INDEFINITELY  0 // Never auto-suspend

//Settings for backlight timer 

#define BACKLIGHT_TIMEOUT_INDEFINITELY 0

#define BACKLIGHT_TIMEOUT_TEN_SEC      10    //Battery mode only

#define BACKLIGHT_TIMEOUT_THIRTY_SEC   30    //Battery mode only

#define BACKLIGHT_TIMEOUT_ONE_MIN      60

#define BACKLIGHT_TIMEOUT_TWO_MIN      120

#define BACKLIGHT_TIMEOUT_THREE_MIN    180

#define BACKLIGHT_TIMEOUT_FOUR_MIN     240

#define BACKLIGHT_TIMEOUT_FIVE_MIN     300

#define BACKLIGHT_TIMEOUT_SIX_MIN      360   //external power mode only

#define BACKLIGHT_TIMEOUT_SEVEN_MIN    420   //external power mode only

#define BACKLIGHT_TIMEOUT_EIGHT_MIN    480   //external power mode only

#define BACKLIGHT_TIMEOUT_NINE_MIN     540   //external power mode only

#define BACKLIGHT_TIMEOUT_TEN_MIN      600   //external power mode only


//Settings for power 
#define SYS_WLAN_POWER_OFF (FALSE)

#define SYS_WLAN_POWER_ON  (TRUE)


#define SYS_BT_POWER_OFF   (FALSE)

#define SYS_BT_POWER_ON    (TRUE)


//Settings of backlight levels 

#define SYS_BACKLIGHT_LEVEL_MINIMUM 0

#define SYS_BACKLIGHT_LEVEL_1       1

#define SYS_BACKLIGHT_LEVEL_2       2

#define SYS_BACKLIGHT_LEVEL_3       3

#define SYS_BACKLIGHT_LEVEL_4       4

#define SYS_BACKLIGHT_LEVEL_MAXIMUM 5


//Settings for Key
#define WM_INPUT_MODE_CHANGE  (WM_APP + 103)  

#define SYS_INPUT_MODE_NORMAL (0x00)

#define SYS_INPUT_MODE_ALPHA  (0x01)

#define SYS_INPUT_MODE_FN     (0x02)

#endif